apiVersion: apps/v1
kind: StatefulSet
metadata:
  labels:
    name: redis-kube
  name: redis-kube
  namespace: ci
spec:
  podManagementPolicy: Parallel
  replicas: 3
  selector:
    matchLabels:
      name: redis-kube
  serviceName: redis-kube
  template:
    metadata:
      labels:
        name: redis-kube
    spec:
      affinity:
        podAntiAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ "redis-kube" ]
            topologyKey: kubernetes.io/hostname
      containers:
      - env:
        - name: DEBUG
          value: yay
        - name: REDIS_DOWN_TIMEOUT
          value: "3"
        - name: REDIS_HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: REDIS_QUORUM
          value: "2"
        - name: REDIS_REPLICASET
          value: redis-kube
        - name: SENTINEL_SVC
          value: redis-kube-clients
        - name: TZ
          value: Europe/Paris
        image: registry.gitlab.com/synacksynack/opsperator/docker-redis:master
        imagePullPolicy: Always
        livenessProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 10
          tcpSocket:
            port: 6379
          timeoutSeconds: 2
        name: redis
        ports:
        - containerPort: 6379
          name: redis
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - "-i"
            - "-c"
            - /is-ready.sh
          failureThreshold: 3
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 1
        resources:
          limits:
            cpu: 100m
            memory: 256Mi
          requests:
            cpu: 50m
            memory: 128Mi
        volumeMounts:
        - mountPath: /var/lib/redis/data
          name: data
      - env:
        - name: DEBUG
          value: yay
        - name: REDIS_HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: REDIS_DOWN_TIMEOUT
          value: "3"
        - name: REDIS_QUORUM
          value: "2"
        - name: REDIS_REPLICASET
          value: redis-kube
        - name: IS_SENTINEL
          value: sure
        - name: SENTINEL_SVC
          value: redis-kube-clients
        - name: TZ
          value: Europe/Paris
        image: registry.gitlab.com/synacksynack/opsperator/docker-redis:master
        imagePullPolicy: Always
        livenessProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 10
          tcpSocket:
            port: 26379
          timeoutSeconds: 2
        name: sentinel
        ports:
        - containerPort: 26379
          name: sentinel
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - "-i"
            - "-c"
            - /is-ready.sh
          failureThreshold: 3
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 1
        resources:
          limits:
            cpu: 100m
            memory: 256Mi
          requests:
            cpu: 50m
            memory: 128Mi
      - image: registry.gitlab.com/synacksynack/opsperator/docker-redisexporter:master
        imagePullPolicy: IfNotPresent
        livenessProbe:
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
          protocol: TCP
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            path: /
            port: 9113
          timeoutSeconds: 3
        resources:
          limits:
            cpu: 200m
            memory: 128Mi
          requests:
            cpu: 100m
            memory: 64Mi
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: 2Gi
